#!/bin/bash

MAJOR_USERS_CGROUP=users

SCRIPT_PATH=/PATH_TO_SCRIPTS/
LOG_FILE=/var/log/cgroup_conf.log

CPU_PERIOD=100000 # in 100ms

MAX_CPU_USAGE_PERC_ALL=95 # in %
MEMORY_USAGE_PERC_ALL=95
CPU_SHARE_ALL=1024

MAX_CPU_USAGE_PERC_USER=90 # in %
MEMORY_USAGE_PERC_USER=90
CPU_SHARE_USER=1024

MIN_UID=500

if [ "x$PAM_TYPE" = "xopen_session" ]; then

  #echo $UID  >> $LOG_FILE

  PU_UID=`id -u $PAM_USER`
  #echo "session: $PAM_USER $PU_UID"  >> $LOG_FILE

  if [ $PU_UID -ge $MIN_UID ]; then

    PU_GID=`id -g $PAM_USER`
    PU_UID=`id -u $PAM_USER`

    USER_CGROUP=$MAJOR_USERS_CGROUP/students

    if [ $PU_GID -lt 10000 ]; then
      USER_CGROUP=$MAJOR_USERS_CGROUP/staff
    fi

    echo $$ >> /sys/fs/cgroup/memory/tasks
    echo $$ >> /sys/fs/cgroup/cpu,cpuacct/tasks

    if [ ! -d /sys/fs/cgroup/cpu,cpuacct/$MAJOR_USERS_CGROUP ]; then
      $SCRIPT_PATH/cgroups_ctrl.sh create $MAJOR_USERS_CGROUP
      $SCRIPT_PATH/cgroups_ctrl.sh config $MAJOR_USERS_CGROUP $CPU_PERIOD $MAX_CPU_USAGE_PERC_ALL $MEMORY_USAGE_PERC_ALL $CPU_SHARE_ALL
    fi

    if [ ! -d /sys/fs/cgroup/cpu,cpuacct/$USER_CGROUP ]; then
      $SCRIPT_PATH/cgroups_ctrl.sh create $USER_CGROUP
      $SCRIPT_PATH/cgroups_ctrl.sh config $USER_CGROUP $CPU_PERIOD $MAX_CPU_USAGE_PERC_ALL $MEMORY_USAGE_PERC_ALL $CPU_SHARE_ALL
    fi

    if [ ! -d /sys/fs/cgroup/cpu,cpuacct/$USER_CGROUP/$PAM_USER ]; then
      $SCRIPT_PATH/cgroups_ctrl.sh create $USER_CGROUP/$PAM_USER
      $SCRIPT_PATH/cgroups_ctrl.sh config $USER_CGROUP/$PAM_USER $CPU_PERIOD $MAX_CPU_USAGE_PERC_USER $MEMORY_USAGE_PERC_USER $CPU_SHARE_USER
    fi


    cgclassify -g cpu,cpuacct:$USER_CGROUP/$PAM_USER $PPID >> $LOG_FILE 2>&1
    cgclassify -g memory:$USER_CGROUP/$PAM_USER $PPID >> $LOG_FILE 2>&1

    cgclassify -g cpu,cpuacct:$USER_CGROUP/$PAM_USER $$ >> $LOG_FILE 2>&1
    cgclassify -g memory:$USER_CGROUP/$PAM_USER $$ >> $LOG_FILE 2>&1
  fi
fi
